image: node:13

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .npm/
    - node_modules/

stages:
  - setup
  - build
  - test

## Development Pipeline

setup_development:
  stage: setup
  tags:
    - mignon_1
  only:
    - 7.0.0
  script:
    - npm ci --cache .npm --prefer-offline

build_development:
  stage: build
  tags:
    - mignon_1
  only:
    - 7.0.0
  script:
    - npm run build
  artifacts:
    paths:
      - node_modules/@nestjs/

test_development:
  stage: test
  tags:
    - mignon_1
  only:
    - 7.0.0
  script:
    - npm run test

## Master Pipeline

setup_master:
  stage: setup
  tags:
    - mignon_2
  only:
    - master
  script:
    - npm ci

build_master:
  stage: build
  tags:
    - mignon_2
  only:
    - master
  script:
    - npm run build
  artifacts:
    paths:
      - node_modules/@nestjs/

test_master:
  stage: test
  tags:
    - mignon_2
  only:
    - master
  script:
    - npm run test

